package com.bzd.web.controller.xsgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.xsgl.SXsglXsmxDdmxSalesorderinfoService;

import java.util.List;

/**
*
* 销售订单明细表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "xsgl/sxsglxsmxddmxsalesorderinfo")
public class SXsglXsmxDdmxSalesorderinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "xsgl";

    @Autowired
    private SXsglXsmxDdmxSalesorderinfoService sXsglXsmxDdmxSalesorderinfoService;

    /**
    * 销售订单明细表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxDdmxSalesorderinfoAdd")
    public String add() {
        return prefix + "/SXsglXsmxDdmxSalesorderinfoAdd";
    }

    /**
    * 销售订单明细表 新增
    *
    * @return
    */
    @Log(title = "销售订单明细表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sXsglXsmxDdmxSalesorderinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sXsglXsmxDdmxSalesorderinfoService.addSXsglXsmxDdmxSalesorderinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 销售订单明细表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("xsgl:xs:view")
    @GetMapping("/sXsglXsmxDdmxSalesorderinfoView")
    public String sxsglxsmxddmxsalesorderinfoListView() {
        return prefix + "/SXsglXsmxDdmxSalesorderinfoList";
    }

    /**
    * 销售订单明细表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:sXsglXsmxDdmxSalesorderinfoList")
    @PostMapping("/sXsglXsmxDdmxSalesorderinfoList")
    @ResponseBody
    public TableDataInfo sxsglxsmxddmxsalesorderinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sXsglXsmxDdmxSalesorderinfoService.findSXsglXsmxDdmxSalesorderinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 销售订单明细表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:remove")
    @Log(title = "销售订单明细表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sXsglXsmxDdmxSalesorderinfoRemove")
    @ResponseBody
    public AjaxResult sxsglxsmxddmxsalesorderinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sXsglXsmxDdmxSalesorderinfoService.SXsglXsmxDdmxSalesorderinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 销售订单明细表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("xsgl:xs:edit")
    @GetMapping("/sXsglXsmxDdmxSalesorderinfoEdit/{id}")
    public String sxsglxsmxddmxsalesorderinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sXsglXsmxDdmxSalesorderinfoService.findSXsglXsmxDdmxSalesorderinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sxsglxsmxddmxsalesorderinfoPageEdit";
        }
        return prefix+ "/sxsglxsmxddmxsalesorderinfoEdit";
    }

    /**
    * 销售订单明细表保存修改的数据
    */
    @RequiresPermissions("xsgl:xs:edit")
    @Log(title = "销售订单明细表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sXsglXsmxDdmxSalesorderinfoEdit")
    @ResponseBody
    public AjaxResult sxsglxsmxddmxsalesorderinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sXsglXsmxDdmxSalesorderinfoService.updateSXsglXsmxDdmxSalesorderinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sxsglxsmxddmxsalesorderinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sxsglxsmxddmxsalesorderinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
